## ros-crystal-rclpy 0.6.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rclpy C)

# Default to C11
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 11)
endif()
if(CMAKE_COMPILER_IS_GNUCC OR CMAKE_C_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra)
endif()

find_package(ament_cmake REQUIRED)
find_package(ament_cmake_python REQUIRED)
find_package(rcl REQUIRED)
find_package(rcl_action REQUIRED)
find_package(rcl_yaml_param_parser REQUIRED)
find_package(rcutils REQUIRED)
find_package(rmw REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

find_package(python_cmake_module REQUIRED)
find_package(PythonExtra MODULE REQUIRED)

set(_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}")

if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
endif()

# enables using the Python extensions from the build space for testing
file(WRITE "${CMAKE_CURRENT_BINARY_DIR}/test_rclpy/__init__.py" "")

ament_python_install_package(${PROJECT_NAME})

function(set_properties _targetname _build_type)
  set_target_properties(${_targetname} PROPERTIES
    PREFIX ""
    LIBRARY_OUTPUT_DIRECTORY${_build_type} "${CMAKE_CURRENT_BINARY_DIR}/test_${PROJECT_NAME}"
    RUNTIME_OUTPUT_DIRECTORY${_build_type} "${CMAKE_CURRENT_BINARY_DIR}/test_${PROJECT_NAME}"
    OUTPUT_NAME "_${_targetname}${PythonExtra_EXTENSION_SUFFIX}"
    SUFFIX "${PythonExtra_EXTENSION_EXTENSION}")
endfunction()

# Only build the library if a C typesupport exists
get_rmw_typesupport(typesupport_impls "rmw_implementation" LANGUAGE "c")
if(typesupport_impls STREQUAL "")
  message(STATUS "Skipping rclpy because no C typesupport library was found.")
  return()
endif()

function(configure_python_c_extension_library _library_name)
  set_properties(${_library_name} "")
  if(WIN32)
    set_properties(${_library_name} "_DEBUG")
    set_properties(${_library_name} "_MINSIZEREL")
    set_properties(${_library_name} "_RELEASE")
    set_properties(${_library_name} "_RELWITHDEBINFO")
  endif()

  target_link_libraries(${_library_name}
    ${PythonExtra_LIBRARIES}
  )

  target_include_directories(${_library_name}
    PUBLIC
    ${PythonExtra_INCLUDE_DIRS}
  )

  install(TARGETS ${_library_name}
    DESTINATION "${PYTHON_INSTALL_DIR}/${PROJECT_NAME}"
  )
endfunction()

add_library(rclpy_common
  SHARED src/rclpy_common/src/common.c
)
target_link_libraries(rclpy_common
  ${PythonExtra_LIBRARIES}
)
target_include_directories(rclpy_common
  PUBLIC
  src/rclpy_common/include
  ${PythonExtra_INCLUDE_DIRS}
)
ament_target_dependencies(rclpy_common
  "rmw"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(rclpy_common PRIVATE "RCLPY_COMMON_BUILDING_DLL")

install(TARGETS rclpy_common
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

add_library(
  rclpy
  SHARED src/rclpy/_rclpy.c
)
target_link_libraries(rclpy
  rclpy_common
)

configure_python_c_extension_library(rclpy)
ament_target_dependencies(rclpy
  "rcl"
  "rcl_yaml_param_parser"
  "rcutils"
)

add_library(
  rclpy_action
  SHARED src/rclpy/_rclpy_action.c
)
target_link_libraries(rclpy_action
  rclpy_common
)

configure_python_c_extension_library(rclpy_action)
ament_target_dependencies(rclpy_action
  "rcl"
  "rcl_action"
  "rcutils"
)

# Logging support provided by rcutils
add_library(
  rclpy_logging
  SHARED src/rclpy/_rclpy_logging.c
)
configure_python_c_extension_library(rclpy_logging)
ament_target_dependencies(rclpy_logging
  "rcutils"
)

if(NOT WIN32)
  ament_environment_hooks(
    "${ament_cmake_package_templates_ENVIRONMENT_HOOK_LIBRARY_PATH}"
  )
endif()

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  find_package(ament_cmake_pytest REQUIRED)

  rosidl_generator_py_get_typesupports(_typesupport_impls)
  ament_index_get_prefix_path(ament_index_build_path SKIP_AMENT_PREFIX_PATH)
  # Get the first item (it will be the build space version of the build path).
  list(GET ament_index_build_path 0 ament_index_build_path)
  if(WIN32)
    # On Windows prevent CMake errors and prevent it being evaluated as a list.
    string(REPLACE "\\" "/" ament_index_build_path "${ament_index_build_path}")
  endif()
  if(NOT _typesupport_impls STREQUAL "")
    ament_add_pytest_test(rclpytests test
      PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}"
      APPEND_ENV AMENT_PREFIX_PATH=${ament_index_build_path}
        PYTHONPATH=${CMAKE_CURRENT_BINARY_DIR}
      TIMEOUT 200
    )
  endif()
endif()
set(PYTHON_EXECUTABLE "${_PYTHON_EXECUTABLE}")

ament_package()

=== debian/changelog ===
ros-crystal-rclpy (0.6.5-1bionic) bionic; urgency=high

  * Send feedback callbacks properly in send_goal() of action client (#451 <https://github.com/ros2/rclpy/issues/451>) (#467 <https://github.com/ros2/rclpy/issues/467>)
  * Action server: catch exception from user execute callback (#437 <https://github.com/ros2/rclpy/issues/437>)
  * Contributors: Jacob Perron, Werner Neubauer

 -- William Woodall <william@osrfoundation.org>  Thu, 05 Dec 2019 08:00:00 -0000

ros-crystal-rclpy (0.6.4-1bionic) bionic; urgency=high

  * Backport fix sigint guard condition lifecycle bug (#298 <https://github.com/ros2/rclpy/issues/298>)
  * Contributors: Wei Liu

 -- William Woodall <william@osrfoundation.org>  Fri, 29 Mar 2019 07:00:00 -0000

ros-crystal-rclpy (0.6.3-1bionic) bionic; urgency=high

  * Backport Python Actions (#282 <https://github.com/ros2/rclpy/issues/282>)
    * Add Action Client (#262 <https://github.com/ros2/rclpy/issues/262>)
    * Add rclpy_action module
    * Implement action client
    * Move common conversion function and typedefs to shared header file (impl/common.h)
    * Add tests using mock action server
    * Add action module for aggregating action related submodules
    * Extend Waitable API so executors are aware of Futures
    * Move check_for_type_support() to its own module
    * Fix Executor not executing tasks if there are no ready entities in the wait set (#272 <https://github.com/ros2/rclpy/issues/272>)
    * Fix Node's reference to executor (#275 <https://github.com/ros2/rclpy/issues/275>)
    * Abstract type conversions into functions (#269 <https://github.com/ros2/rclpy/issues/269>)
    * Abstract type conversions into functions
    * Move common C functions to a shared library 'rclpy_common'
    * Add ActionServer (#270 <https://github.com/ros2/rclpy/issues/270>)
    * Add Action server functions to extension module
    * Separated service related macros into separate request and response calls
    * Add server goal handle functions to extension module
    * Update Action extension module to use conversion functions
    * Add implementation of Python ActionServer
    * Handles goal and cancel requests, responds, and calls user-defined functions for executing goals.
    * Handle result requests
    * Handle expired goals
    * Publish goal status array and feedback
    * Add handle_accepted_callback to ActionServer
    * Enable test using MultiThreadedExecutor (#280 <https://github.com/ros2/rclpy/issues/280>)
    * Guard against failed take when taking action messages (#281 <https://github.com/ros2/rclpy/issues/281>)
  * Contributors: Jacob Perron

 -- William Woodall <william@osrfoundation.org>  Sat, 09 Mar 2019 08:00:00 -0000

ros-crystal-rclpy (0.6.2-1bionic) bionic; urgency=high

  * Added Waitable to callback group (#265 <https://github.com/ros2/rclpy/issues/265>)
  * Fixed flake8 error (#263 <https://github.com/ros2/rclpy/issues/263>)
  * Added HIDDEN_NODE_PREFIX definition to node.py (#259 <https://github.com/ros2/rclpy/issues/259>)
  * Added rclpy raw subscriptions (#242 <https://github.com/ros2/rclpy/issues/242>)
  * Added a test for invalid string checks on publishing (#256 <https://github.com/ros2/rclpy/issues/256>)
  * Contributors: AAlon, Jacob Perron, Joseph Duchesne, Michel Hidalgo, Shane Loretz

 -- William Woodall <william@osrfoundation.org>  Fri, 08 Feb 2019 08:00:00 -0000

ros-crystal-rclpy (0.6.1-1bionic) bionic; urgency=high

  * Added node graph functions (#247 <https://github.com/ros2/rclpy/issues/247>)
  * Filled ParameterEvent.msg with timestamp and node path name (#252 <https://github.com/ros2/rclpy/issues/252>)
  * Fixed spelling in documentation (#251 <https://github.com/ros2/rclpy/issues/251>)
  * Added Waitaible and wait set APIs (#250 <https://github.com/ros2/rclpy/issues/250>)
  * Updated rcl_wait_set_add_* calls (#248 <https://github.com/ros2/rclpy/issues/248>)
  * Contributors: Brian, Dirk Thomas, Jacob Perron, Ross Desmond, Shane Loretz, Tully Foote, William Woodall

 -- William Woodall <william@osrfoundation.org>  Fri, 07 Dec 2018 08:00:00 -0000

ros-crystal-rclpy (0.6.0-1bionic) bionic; urgency=high

  * Updated to use new error handling API from rcutils (#245 <https://github.com/ros2/rclpy/issues/245>)
  * Added library path hook for platforms other than Windows. (#243 <https://github.com/ros2/rclpy/issues/243>)
  * Avoided use of MethodType when monkey patching for tests (#239 <https://github.com/ros2/rclpy/issues/239>)
  * Fixed repeated fini-ing on failure to parse yaml params (#238 <https://github.com/ros2/rclpy/issues/238>)
  * Added methods on Mock class for Python 3.5 compatibility (#237 <https://github.com/ros2/rclpy/issues/237>)
  * Added getter for tuple with seconds and nanoseconds (#235 <https://github.com/ros2/rclpy/issues/235>)
  * Added new method to get node names and namespaces (#233 <https://github.com/ros2/rclpy/issues/233>)
  * Fixed warning when parameter value is uninitialized. (#234 <https://github.com/ros2/rclpy/issues/234>)
  * Added initial node parameters from a parameters yaml files and constructor arguments. (#225 <https://github.com/ros2/rclpy/issues/225>)
  * Added callbacks when time jumps (#222 <https://github.com/ros2/rclpy/issues/222>)
  * Updated to use consolidated rcl_wait_set_clear() (#230 <https://github.com/ros2/rclpy/issues/230>)
  * Added parameter events publishing (#226 <https://github.com/ros2/rclpy/issues/226>)
  * Added Node API method for setting the parameters_callback. (#228 <https://github.com/ros2/rclpy/issues/228>)
  * Added test for when sim time is active but unset (#229 <https://github.com/ros2/rclpy/issues/229>)
  * Added node parameters and parameter services (#214 <https://github.com/ros2/rclpy/issues/214>)
  * Disabled 1kHz test on all platforms (#223 <https://github.com/ros2/rclpy/issues/223>)
  * Updated to allow duration to be initialized with negative nanoseconds (#221 <https://github.com/ros2/rclpy/issues/221>)


=== debian/control ===
Source: ros-crystal-rclpy
Section: misc
Priority: optional
Maintainer: William Woodall <william@osrfoundation.org>
Build-Depends: debhelper (>= 9.0.0), python3-pytest, ros-crystal-ament-cmake, ros-crystal-ament-cmake-pytest, ros-crystal-ament-lint-auto, ros-crystal-ament-lint-common, ros-crystal-python-cmake-module, ros-crystal-rcl, ros-crystal-rcl-action, ros-crystal-rcl-interfaces, ros-crystal-rcl-yaml-param-parser, ros-crystal-rcutils, ros-crystal-rmw-implementation, ros-crystal-rmw-implementation-cmake, ros-crystal-rosidl-generator-py, ros-crystal-test-msgs, ros-crystal-unique-identifier-msgs, ros-crystal-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-crystal-rclpy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-crystal-ament-index-python, ros-crystal-builtin-interfaces, ros-crystal-rcl, ros-crystal-rcl-action, ros-crystal-rcl-yaml-param-parser, ros-crystal-rmw-implementation, ros-crystal-unique-identifier-msgs, ros-crystal-ros-workspace
Description: Package containing the Python client.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-rclpy//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
